diff -c gcc-3.3.2-orig-gcc/real.h gcc-3.3.2-patched-gcc/real.h
*** gcc-3.3.2-orig-gcc/real.h	Tue Jul  1 21:28:45 2003
--- gcc-3.3.2-patched-gcc/real.h	Sat Feb  7 21:33:06 2004
***************
*** 40,52 ****
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) class : 2;
    unsigned int sign : 1;
    signed int exp : EXP_BITS;
    unsigned long sig[SIGSZ];
  };
  
  /* Various headers condition prototypes on #ifdef REAL_VALUE_TYPE, so it
     needs to be a macro.  We do need to continue to have a structure tag
--- 40,62 ----
  #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
  #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
  
+ /* Can't have "class" in C++, but gentype gets confused on #ifdefs
+    within the struct. */
+ #ifndef __cplusplus
+ # define REAL_CLASSY class
+ #else
+ # define REAL_CLASSY cl
+ #endif
+ 
  struct real_value GTY(())
  {
!   ENUM_BITFIELD (real_value_class) REAL_CLASSY : 2;
    unsigned int sign : 1;
    signed int exp : EXP_BITS;
    unsigned long sig[SIGSZ];
  };
+ 
+ #undef REAL_CLASSY
  
  /* Various headers condition prototypes on #ifdef REAL_VALUE_TYPE, so it
     needs to be a macro.  We do need to continue to have a structure tag
diff -c gcc-3.3.2-orig-gcc/rtl.h gcc-3.3.2-patched-gcc/rtl.h
*** gcc-3.3.2-orig-gcc/rtl.h	Thu May  1 21:21:07 2003
--- gcc-3.3.2-patched-gcc/rtl.h	Sat Feb  7 21:33:36 2004
***************
*** 111,118 ****
--- 111,123 ----
    int rtint;
    unsigned int rtuint;
    const char *rtstr;
+ #ifndef __cplusplus
    rtx rtx;
    rtvec rtvec;
+ #else
+   rtx rt_rtx;
+   rtvec rt_vec;
+ #endif
    enum machine_mode rttype;
    addr_diff_vec_flags rt_addr_diff_vec_flags;
    struct cselib_val_struct *rt_cselib;
*** gcc-orig/config/rs6000/rs6000.c	Wed Jan 14 09:03:58 2004
--- gcc/config/rs6000/rs6000.c	Sat May 21 16:06:49 2005
***************
*** 387,396 ****
  
  /* ??? Should work everywhere, but ask dje@watson.ibm.com before
     enabling for AIX.  */
! #if TARGET_OBJECT_FORMAT != OBJECT_XCOFF
  #undef TARGET_ASM_CAN_OUTPUT_MI_THUNK
  #define TARGET_ASM_CAN_OUTPUT_MI_THUNK default_can_output_mi_thunk_no_vcall
! #endif
  
  struct gcc_target targetm = TARGET_INITIALIZER;
  
--- 387,396 ----
  
  /* ??? Should work everywhere, but ask dje@watson.ibm.com before
     enabling for AIX.  */
! /*#if TARGET_OBJECT_FORMAT != OBJECT_XCOFF*//*enabled for gdc*/
  #undef TARGET_ASM_CAN_OUTPUT_MI_THUNK
  #define TARGET_ASM_CAN_OUTPUT_MI_THUNK default_can_output_mi_thunk_no_vcall
! /*#endif*/
  
  struct gcc_target targetm = TARGET_INITIALIZER;
  
***************
*** 11193,11199 ****
           although IBM appears to be using 13.  There is no official value
  	 for Chill, so we've chosen 44 pseudo-randomly.  */
        if (! strcmp (language_string, "GNU C")
! 	  || ! strcmp (language_string, "GNU Objective-C"))
  	i = 0;
        else if (! strcmp (language_string, "GNU F77"))
  	i = 1;
--- 11193,11200 ----
           although IBM appears to be using 13.  There is no official value
  	 for Chill, so we've chosen 44 pseudo-randomly.  */
        if (! strcmp (language_string, "GNU C")
! 	  || ! strcmp (language_string, "GNU Objective-C")
! 	  || ! strcmp (language_string, "GNU D"))
  	i = 0;
        else if (! strcmp (language_string, "GNU F77"))
  	i = 1;
diff -c gcc-orig/function.c gcc/function.c
*** gcc-orig/function.c	Sat May 28 17:02:12 2005
--- gcc/function.c	Thu Jun  9 19:56:31 2005
***************
*** 6575,6585 ****
      {
        last_ptr = assign_stack_local (Pmode, GET_MODE_SIZE (Pmode), 0);
  
!       /* Delay copying static chain if it is not a register to avoid
! 	 conflicts with regs used for parameters.  */
!       if (! SMALL_REGISTER_CLASSES
! 	  || GET_CODE (static_chain_incoming_rtx) == REG)
! 	emit_move_insn (last_ptr, static_chain_incoming_rtx);
      }
  
    /* If the parameters of this function need cleaning up, get a label
--- 6575,6588 ----
      {
        last_ptr = assign_stack_local (Pmode, GET_MODE_SIZE (Pmode), 0);
  
!       if (cfun->static_chain_expr == NULL_TREE)
!         {
! 	  /* Delay copying static chain if it is not a register to avoid
! 	     conflicts with regs used for parameters.  */
! 	  if (! SMALL_REGISTER_CLASSES
! 	      || GET_CODE (static_chain_incoming_rtx) == REG)
! 	    emit_move_insn (last_ptr, static_chain_incoming_rtx);
! 	}
      }
  
    /* If the parameters of this function need cleaning up, get a label
***************
*** 6666,6675 ****
  
    /* Copy the static chain now if it wasn't a register.  The delay is to
       avoid conflicts with the parameter passing registers.  */
! 
!   if (SMALL_REGISTER_CLASSES && current_function_needs_context)
!     if (GET_CODE (static_chain_incoming_rtx) != REG)
!       emit_move_insn (last_ptr, static_chain_incoming_rtx);
  
    /* The following was moved from init_function_start.
       The move is supposed to make sdb output more accurate.  */
--- 6669,6680 ----
  
    /* Copy the static chain now if it wasn't a register.  The delay is to
       avoid conflicts with the parameter passing registers.  */
!   if (cfun->static_chain_expr == NULL_TREE)
!     {
!       if (SMALL_REGISTER_CLASSES && current_function_needs_context)
! 	if (GET_CODE (static_chain_incoming_rtx) != REG)
! 	  emit_move_insn (last_ptr, static_chain_incoming_rtx);
!     }
  
    /* The following was moved from init_function_start.
       The move is supposed to make sdb output more accurate.  */
***************
*** 6694,6703 ****
  	  /* If the static chain originally came in a register, put it back
  	     there, then move it out in the next insn.  The reason for
  	     this peculiar code is to satisfy function integration.  */
! 	  if (SMALL_REGISTER_CLASSES
! 	      && GET_CODE (static_chain_incoming_rtx) == REG)
! 	    emit_move_insn (static_chain_incoming_rtx, last_ptr);
! 	  last_ptr = copy_to_reg (static_chain_incoming_rtx);
  	}
  
        while (tem)
--- 6699,6719 ----
  	  /* If the static chain originally came in a register, put it back
  	     there, then move it out in the next insn.  The reason for
  	     this peculiar code is to satisfy function integration.  */
! 	  if (cfun->static_chain_expr == NULL_TREE)
! 	    {
! 	      if (SMALL_REGISTER_CLASSES
! 		  && GET_CODE (static_chain_incoming_rtx) == REG)
! 		emit_move_insn (static_chain_incoming_rtx, last_ptr);
! 	      last_ptr = copy_to_reg (static_chain_incoming_rtx);
! 	    }
! 	  else
! 	    {
! 		rtx r = expand_expr (cfun->static_chain_expr, NULL_RTX,
! 		    VOIDmode, EXPAND_NORMAL);
! 		r = copy_to_reg (r);
! 		emit_move_insn (last_ptr, r);
! 	        last_ptr = r;
! 	    }
  	}
  
        while (tem)
diff -c gcc-orig/function.h gcc/function.h
*** gcc-orig/function.h	Fri Nov 14 01:46:09 2003
--- gcc/function.h	Wed Jun  8 19:03:37 2005
***************
*** 508,513 ****
--- 508,517 ----
    /* Maximal number of entities in the single jumptable.  Used to estimate
       final flowgraph size.  */
    int max_jumptable_ents;
+ 
+   /* Expression to be evaluated to get the static chain.  If NULL,
+      the standard trampoline method is used. */
+   tree static_chain_expr;
  };
  
  /* The function currently being compiled.  */
diff -cr gcc-orig/dwarf2.h gcc/dwarf2.h
*** gcc-orig/dwarf2.h	Sun Sep  8 18:36:53 2002
--- gcc/dwarf2.h	Thu Sep 22 13:11:27 2005
***************
*** 588,593 ****
--- 588,594 ----
      DW_LANG_C99 = 0x000c,
      DW_LANG_Ada95 = 0x000d,
      DW_LANG_Fortran95 = 0x000e,
+     DW_LANG_D = 0x0013,
      /* MIPS.  */
      DW_LANG_Mips_Assembler = 0x8001
    };
diff -cr gcc-orig/dwarf2out.c gcc/dwarf2out.c
*** gcc-orig/dwarf2out.c	Wed Oct  1 16:58:30 2003
--- gcc/dwarf2out.c	Thu Sep 22 13:17:56 2005
***************
*** 4956,4962 ****
    unsigned lang = get_AT_unsigned (comp_unit_die, DW_AT_language);
  
    return (lang == DW_LANG_C || lang == DW_LANG_C89
! 	  || lang == DW_LANG_C_plus_plus);
  }
  
  static inline int
--- 4956,4963 ----
    unsigned lang = get_AT_unsigned (comp_unit_die, DW_AT_language);
  
    return (lang == DW_LANG_C || lang == DW_LANG_C89
! 	  || lang == DW_LANG_C_plus_plus
! 	  || lang == DW_LANG_D);
  }
  
  static inline int
***************
*** 11235,11240 ****
--- 11236,11243 ----
      language = DW_LANG_Pascal83;
    else if (strcmp (language_string, "GNU Java") == 0)
      language = DW_LANG_Java;
+   else if (strcmp (language_string, "GNU D") == 0)
+     language = DW_LANG_D;
    else
      language = DW_LANG_C89;
  
***************
*** 12630,12636 ****
  	    add_child_die (comp_unit_die, die);
  	  else if (node->created_for
  		   && ((DECL_P (node->created_for)
! 			&& (context = DECL_CONTEXT (node->created_for)))
  		       || (TYPE_P (node->created_for)
  			   && (context = TYPE_CONTEXT (node->created_for))))
  		   && TREE_CODE (context) == FUNCTION_DECL)
--- 12633,12639 ----
  	    add_child_die (comp_unit_die, die);
  	  else if (node->created_for
  		   && ((DECL_P (node->created_for)
! 			&& (context = decl_function_context (node->created_for)))
  		       || (TYPE_P (node->created_for)
  			   && (context = TYPE_CONTEXT (node->created_for))))
  		   && TREE_CODE (context) == FUNCTION_DECL)
